Loading...
Searching...
No Matches
Content-Length Header
MIME Headers

The Content-Length header indicates the size of the message-body in decimal number of octets. More...

## Data Structures

struct | msg_content_length_s
| Structure for Content-Length header. More...

## Macros

#define | MSG_CONTENT_LENGTH_INIT()
| Initializer for an msg_content_length_t structure.

## Typedefs

typedef struct msg_content_length_s | msg_content_length_t
| The structure msg_content_length_t contains representation of a Content-Length header.

## Enumerations

enum | { msg_content_length_hash }

## Functions

msg_content_length_t * | msg_content_length_init (msg_content_length_t x[1])
| Initialize an msg_content_length_t structure.
int | msg_is_content_length (msg_header_t const *header)
| Test if header object is an instance of msg_content_length_t.
msg_content_length_t * | msg_content_length_dup (su_home_t *home, msg_content_length_t const *header)
| Duplicate (deep copy) msg_content_length_t.
msg_content_length_t * | msg_content_length_copy (su_home_t *home, msg_content_length_t const *header)
| Copy an msg_content_length_t header structure.
msg_content_length_t * | msg_content_length_make (su_home_t *home, char const *s)
| Make a header structure msg_content_length_t.
msg_content_length_t * | msg_content_length_format (su_home_t *home, char const *fmt,...)))
| Make a Content-Length header from formatting result.
msg_content_length_t * | msg_content_length_create (su_home_t *home, uint32_t n)
| Create a Content-Length header object.

## Variables

msg_parse_f | msg_content_length_d
| Parse a Content-Length header.
msg_print_f | msg_content_length_e
| Print a Content-Length header.
msg_hclass_t | msg_content_length_class []
| Header class for Content-Length header.

## Detailed Description

The Content-Length header indicates the size of the message-body in decimal number of octets.

Its syntax is defined in [S10.18] as follows:

Content-Length = ( "Content-Length" / "l" ) HCOLON 1*DIGIT

## Macro Definition Documentation

## MSG_CONTENT_LENGTH_INIT

#define MSG_CONTENT_LENGTH_INIT | ( |  | ) |

Initializer for an msg_content_length_t structure.

A static msg_content_length_t structure must be initialized with the MSG_CONTENT_LENGTH_INIT() macro. For instance,

msg_content_length_t msg_content_length = MSG_CONTENT_LENGTH_INIT;
msg_content_length_t
struct msg_content_length_s msg_content_length_t
The structure msg_content_length_t contains representation of a Content-Length header.
Definition msg_mime.h:64
MSG_CONTENT_LENGTH_INIT
#define MSG_CONTENT_LENGTH_INIT()
Initializer for an msg_content_length_t structure.
Definition msg_mime_protos.h:3352

## Typedef Documentation

## msg_content_length_t

typedef struct msg_content_length_s msg_content_length_t

The structure msg_content_length_t contains representation of a Content-Length header.

The msg_content_length_t is defined as follows:

typedef struct msg_content_length_s {
msg_common_t l_common[1]; // Common fragment info
msg_error_t *l_next; // Link to next (dummy)
unsigned long l_length; // Numeric value
} msg_content_length_t;
msg_error_t
struct msg_error_s msg_error_t
Type for erroneous headers.
Definition msg_types.h:94
msg_common_t
struct msg_common_s msg_common_t
Common part of header.
Definition msg_types.h:89
msg_content_length_s
Structure for Content-Length header.
Definition msg_mime.h:121
msg_content_length_s::l_next
msg_error_t * l_next
Link to next (dummy).
Definition msg_mime.h:123
msg_content_length_s::l_length
unsigned long l_length
Digits.
Definition msg_mime.h:124
msg_content_length_s::l_common
msg_common_t l_common[1]
Common fragment info.
Definition msg_mime.h:122

## Enumeration Type Documentation

## anonymous enum

anonymous enum

Enumerator
msg_content_length_hash | Hash of Content-Length header.

## Function Documentation

## msg_content_length_copy()

msg_content_length_t * msg_content_length_copy | ( | su_home_t * | home,
|  | msg_content_length_t const * | header )

inline

Copy an msg_content_length_t header structure.

The function msg_content_length_copy() copies a header structure header. If the header structure header contains a reference (`header->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header structure header.

Parameters

  home | memory home used to allocate new structure
  header | pointer to the header structure to be duplicated

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old header, including the encoding of the old header, if present.

Example
  content_length = msg_content_length_copy(home, msg->msg_content_length);
  msg_content_length_copy
  msg_content_length_t * msg_content_length_copy(su_home_t *home, msg_content_length_t const *header)
  Copy an msg_content_length_t header structure.
  Definition msg_mime_protos.h:3481

Returns
  The function msg_content_length_copy() returns a pointer to newly copied header structure, or NULL upon an error.

## msg_content_length_create()

msg_content_length_t * msg_content_length_create | ( | su_home_t * | home,
|  | uint32_t | n )

Create a Content-Length header object.

The function msg_content_length_create() creates a Content-Length header object with the value n. The memory for the header is allocated from the memory home home.

Parameters

  home | memory home
  n | payload size in bytes

Returns
  The function msg_content_length_create() returns a pointer to newly created Content-Length header object when successful or NULL upon an error.

## msg_content_length_dup()

msg_content_length_t * msg_content_length_dup | ( | su_home_t * | home,
|  | msg_content_length_t const * | header )

inline

Duplicate (deep copy) msg_content_length_t.

The function msg_content_length_dup() duplicates a header structure header. If the header structure header contains a reference (`header->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  header | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  content_length = msg_content_length_dup(home, msg->msg_content_length);
  msg_content_length_dup
  msg_content_length_t * msg_content_length_dup(su_home_t *home, msg_content_length_t const *header)
  Duplicate (deep copy) msg_content_length_t.
  Definition msg_mime_protos.h:3436

Returns
  The function msg_content_length_dup() returns a pointer to the newly duplicated msg_content_length_t header structure, or NULL upon an error.

## msg_content_length_format()

msg_content_length_t * msg_content_length_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Content-Length header from formatting result.

The function msg_content_length_format() makes a new Content-Length header object using snprintf-formatted result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and uses the formatting result as the header value.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Note
  This function may be implemented as a macro calling msg_header_format().

Returns
  The function msg_content_length_format() returns a pointer to newly makes header structure, or NULL upon an error.

## msg_content_length_init()

msg_content_length_t * msg_content_length_init | ( | msg_content_length_t | x[1] | ) |

inline

Initialize an msg_content_length_t structure.

An msg_content_length_t structure can be initialized with the msg_content_length_init() function/macro. For instance,

msg_content_length_t msg_content_length;
msg_content_length_init(&msg_content_length);
msg_content_length_init
msg_content_length_t * msg_content_length_init(msg_content_length_t x[1])
Initialize an msg_content_length_t structure.
Definition msg_mime_protos.h:3369

Parameters

  x | pointer to msg_content_length_t structure

## msg_content_length_make()

msg_content_length_t * msg_content_length_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a header structure msg_content_length_t.

The function msg_content_length_make() makes a new msg_content_length_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Note
  This function may be implemented as a macro calling msg_header_make().

Returns
  The function msg_content_length_make() returns a pointer to newly maked msg_content_length_t header structure, or NULL upon an error.

## msg_is_content_length()

int msg_is_content_length | ( | msg_header_t const * | header | ) |

inline

Test if header object is an instance of msg_content_length_t.

The function msg_is_content_length() returns true (nonzero) if the header class is an instance of Content-Length header object and false (zero) otherwise.

Parameters

  header | pointer to the header structure to be tested

Returns
  The function msg_is_content_length() returns true (nonzero) if the header object is an instance of header Content-Length header and false (zero) otherwise.

## Variable Documentation

## msg_content_length_class

msg_hclass_t msg_content_length_class[]

extern

Header class for Content-Length header.

The header class msg_content_length_class defines how a Content-Length header header is parsed and printed. It also contains methods used by message parser and other functions to manipulate the msg_content_length_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.